<?php
    use PHPImageWorkshop\ImageWorkshop;
    use GifCreator\GifCreator;
	use GifFrameExtractor\GifFrameExtractor;
    class ImagePlugin extends Plugin
    {
        public $type = 'img';
        public $name = 'Obrazki';

        // OG Tags
        public function ogTags($info)
        {
            return array(
                'title' => $info['title'],
                'image' => kernel::host().'/upload/'.$info['src']
            );
        }
        // User methods
        public function onDisplay($info)
        {
            return '<a href="$1"><img src="'.kernel::host().'/upload/'.$info['src'].'" title="'.$info['title'].'" alt="'.$info['title'].'" /></a>';
        }
        public function onSingleDisplay($info)
        {
            return '<img src="'.kernel::host().'/upload/'.$info['src'].'" title="'.$info['title'].'" alt="'.$info['title'].'" />';
        }
        public function onProfileDisplay($info)
        {
            return kernel::host().'/upload/'.$info['src'];
        }
        public function onSave()
        {
            global $kernel, $page, $user;

    		if(isset($_POST['send_img'])) {
                $max_width = $this->maxObjectWidth;
                $max_file_size = $page->load('max_file_size');
                $owner = $user->userInfo('id');
                $watermark = $page->load('watermark');

        		$overwrite = 0;
        		$dir = 'upload/';
        		$file_types = array(1=>'jpg','jpeg','gif','png','JPG','JPEG','GIF','PNG');
        		$file_mimes = array(1=>'image/jpg', 'image/jpeg', 'image/pjpeg', 'image/gif', 'image/png');
        		$file_name = md5(date('YmdHis').rand(1000,9999));

    			if(empty($_POST['title']) || !$_FILES['image']['name']) { $this->msg($kernel->lang['add']['fillrequired'],1); }
    			else {
    				if(!$this->verifyCaptcha(@$_POST['question'])) $this->msg($kernel->lang['add']['captcha.error'],1);
    				else {
    					$title = mysql_real_escape_string(htmlspecialchars($_POST['title']));
    					if(!empty($_POST['source'])) $source = mysql_real_escape_string(htmlspecialchars($_POST['source']));
    					else $source = '-----';
    					$cat = mysql_real_escape_string(htmlspecialchars($_POST['cat']));
    					$date = date('Y-m-d H:i:s');
    					$is_waiting = 1;
    					$type = 'img';
    					if(empty($_SESSION['login'])) $owner = 0;

    					if(filesize($_FILES['image']['tmp_name']) <= $max_file_size*1024) {
    						$file_ex = pathinfo($_FILES['image']['name']);
    						$image_info = @getimagesize($_FILES['image']['tmp_name']);
    							if(array_search($file_ex['extension'],$file_types) && array_search($image_info['mime'],$file_mimes)) {
    								if($overwrite == 0 && file_exists($dir.$file_name.".".$file_ex['extension'])) $this->msg($kernel->lang['add']['fileExist'],1);
    								if(!move_uploaded_file($_FILES['image']['tmp_name'],$dir.$file_name.".".$file_ex['extension'])) $this->msg($kernel->lang['add']['upload.error'],1);
    								else {
    									$upload_dir = $dir.$file_name.".".$file_ex['extension'];
    									$file_src = $file_name.".".$file_ex['extension'];
    									mysql_query("INSERT INTO `tentego_img` (`title`,`src`,`type`,`owner`,`cat`,`date`,`source`,`is_waiting`)
    												VALUES ('$title','$file_src','$type','$owner','$cat','$date','$source','$is_waiting')");

    									//Zmina rozmiaru obrazka
    									list($width, $height, $type, $attr) = getimagesize($upload_dir);
    									if($width > $max_width) {
    										require_once(ADMIN_DIRECTORY.'/lib/imageworkshop/ImageWorkshop.php');
    										$imageLayer = ImageWorkshop::initFromPath($upload_dir);
    										$imageLayer->resizeInPixel($max_width, null, true);
    										$createFolders = false;
    										$backgroundColor = null;
    										$imageQuality = 95;
    										$imageLayer->save($dir, $file_name.".".$file_ex['extension'], $createFolders, $backgroundColor, $imageQuality);
    									}

    									if($watermark) $this->watermark($upload_dir, $watermark, $dir);
    									$this->msg($kernel->lang['add']['upload.ok'],3);
    								}
    							}
    						else $this->msg($kernel->lang['add']['wrongExt'],1);
    					}
    					else $this->msg(sprintf($kernel->lang['add']['tooLarge'], $max_file_size),1);
    				}
    			}
    		}
        }
        public function form()
        {
            global $kernel, $rewrite, $page, $user;

    		$text = NULL;
    		foreach(self::$categories as $cat) {
    			$text .= '<option value="'.$cat['id'].'">'.$cat['name'].'</option>'."\n";
    		}

            echo '<form action="'.$rewrite->add.'" method="post" enctype="multipart/form-data">
        		<label>'.$kernel->lang['add']['form.name'].'</label>
        		<input type="text" name="title" maxlength="64" value="'.(isset($_POST['title'])?htmlspecialchars($_POST['title']):'').'" />
        		<label>'.$kernel->lang['add']['form.file'].'</label>
        		<input type="file" accept="image/*" name="image" />
        		<label>'.$kernel->lang['add']['form.cat'].'</label>
        		<select name="cat">
        			'.$text.'
        		</select>
        		<label>'.$kernel->lang['add']['form.source'].'</label>
        		<input type="text" name="source" maxlength="64" value="'.(isset($_POST['source'])?htmlspecialchars($_POST['source']):'').'" />
        		<label><img src="'.kernel::host().'/_themes/_captcha/image.php" alt="Captcha"></label>
        		<input type="text" name="question" '.(($page->load("admin_captcha") && $user->verifyLogin() && $user->userInfo('rank') == 0)?'disabled':'').'/>
        		<br/>
        		<input type="submit" name="send_img" value="'.$kernel->lang['add']['form.submit'].'" />
        	</form>';
        }

        // Admin methods
        public function onAdminPreview($info)
        {
            parse_str(parse_url(htmlspecialchars_decode($info['src']), PHP_URL_QUERY), $src);
            return array(
                'url'       => '../upload/'.$info['src'],
                'img'       => '?go=manager&feature=thumb&img=../upload/'.$info['src'].'&token='.$_SESSION[kernel::host().'-us_token'],
            );
        }
        public function onAdminEdit($info)
        {
            $query['categories'] = mysql_query("SELECT * FROM tentego_img_cat");
            while($fetch = mysql_fetch_array(($query['categories'])))
            {
                $categories[] = '<option value="'.$fetch['id'].'"'.( ($fetch['id']==$info['cat'])?' selected':'' ).'>'.$fetch['name'].'</option>';
            }
            $categories = implode("\n", $categories);

            $return = array(
                'Tytuł'     			=> '<input type="text" name="img[title]" value="'.($info['title']).'" />',
                'Adres'     			=> '<input type="text" name="img[src]" value="'.$info['src'].'" />',
                'Data dodania'      	=> '<input type="text" name="img[date]" value="'.date('Y-m-d H:i:s', strtotime($info['date'])).'" />',
				'Data opublikowania'	=> '<input type="text" name="img[rel_date]" value="'.date('Y-m-d H:i:s', strtotime($info['rel_date'])).'" />',
                'Kategoria' 			=> '<select name="img[cat]">'.$categories.'</select>',
                'Źródło'    			=> '<input type="text" name="img[source]" value="'.$info['source'].'" />',
            );

            return $return;
        }
        public function onAdminSave()
        {
            $data = array();
            foreach($_POST['img'] as $key => $content)
            {
                $data[$key] = mysql_real_escape_string(htmlspecialchars($content, ENT_QUOTES));
            }
            $query = sprintf("UPDATE tentego_img SET title = '%s', date = '%s', rel_date = '%s', src = '%s', cat = '%s', source = '%s' WHERE id = %d",
                                $data['title'], $data['date'], $data['rel_date'], $data['src'], $data['cat'], $data['source'], intval($_GET['id']));

            return mysql_query($query);
        }
        public function onAdminDelete($info)
        {
            if(mysql_query("DELETE FROM `tentego_img` WHERE `id`=".$info['id']))
            {
	            if(unlink('../upload/'.$info['src'])) kernel::make_notify("Usunięto obrazek z serwera.");
            	else kernel::make_notify("Wystąpił błąd podczas usuwania obrazka.");
            	kernel::make_notify("Pomyślnie usunięto wpis.");
			}
			else kernel::make_notify("Wystąpił błąd podczas usuwania wpisu.");
        }
    }

?>