<?php
	ini_set('memory_limit', '256M');
    use PHPImageWorkshop\ImageWorkshop;
	use GifCreator\GifCreator;
	use GifFrameExtractor\GifFrameExtractor;
	
    abstract class Plugin {
        protected static $categories = null;
        protected $maxObjectWidth = 980;

        public function __construct()
        {
            if(self::$categories == null)
            {
                $query = mysql_query("SELECT * FROM `tentego_img_cat`");
        		while($cat = mysql_fetch_array($query)) {
        			self::$categories[] = $cat;
        		}
            }
        }
        // OG Tags
        public function ogTags($info)
        {
            return array(
                'title' => $info['title'],
                'image' => kernel::host().'/upload/'.$info['src']
            );
        }
        // Watermark method
        protected function watermark($file, $watermark, $dir)
        {
			global $page;
			
    		require_once(ADMIN_DIRECTORY.'/lib/imageworkshop/ImageWorkshop.php');
			require_once(ADMIN_DIRECTORY.'/lib/imageworkshop/GifFrameExtractor.php');
			require_once(ADMIN_DIRECTORY.'/lib/imageworkshop/GifCreator.php');
    		$info = pathinfo($file);
			
			$experimentalGIF = $page->load("gif_watermark");

    		if($info['extension'] != 'gif' || !GifFrameExtractor::isAnimatedGif($file))
			{
				$imageLayer = ImageWorkshop::initFromPath($file);
				$watermarkLayer = ImageWorkshop::initFromPath($watermark);
				$imageLayer->resizeInPixel($imageLayer->getWidth(), null, true);
				$imageLayer->addLayer(1, $watermarkLayer, 5, 5, "RB");
				$createFolders = false;
				$backgroundColor = null;
				$imageQuality = 100;
				$imageLayer->save($dir, $info['filename'].'.'.$info['extension'], $createFolders, $backgroundColor, $imageQuality);
			}
			else if($experimentalGIF)
			{
				$gfe = new GifFrameExtractor();
				$frames = $gfe->extract($file,true);
				$dimensions = $gfe->getFrameDimensions();
				$positions = $gfe->getFramePositions();
				
				
				$watermarkLayer = ImageWorkshop::initFromPath($watermark);
				$newGif = array();
				
				
				$prevFrame = null;
				foreach($frames as $key => $frame)
				{
					$currentFrame = ImageWorkshop::initFromResourceVar($frame['image']);
					$currentFrame->resizeInPixel($dimensions[$key]['width'], $dimensions[$key]['height'], false);

					if($key == 0)
					{
						$frameLayer = $currentFrame;
					}
					else
					{
						$frameLayer->addLayerOnTop($currentFrame, $positions[$key]['x'], $positions[$key]['y'], "LT");
					}
					
					$watermarkedLayer = clone $frameLayer;
					
					$watermarkedLayer->addLayerOnTop($watermarkLayer, 5, 5, "RB");
					
					$newGif[] = $watermarkedLayer->getResult();
				}
				
				$gc = new GifCreator();
				$gc->create($newGif, $gfe->getFrameDurations(), 0);
				
				file_put_contents($file, $gc->getGif());
			}

    	}
		
		protected function verifyCaptcha($code)
		{
			global $page, $user;
			
			if($user->verifyLogin() && $user->userInfo('rank') == 0 && $page->load('admin_captcha'))
				return true;
			
			if($_SESSION['img_number'] == strtolower($code))
				return true;
			
			return false;
		}
        protected function msg($text, $type) {
    		switch($type) {
    			case 1: $msg = '<div class="msg error">'.$text.'</div>'; break;
    			case 2: $msg = '<div class="msg alert">'.$text.'</div>'; break;
    			case 3: $msg = '<div class="msg good">'.$text.'</div>';
    		}
    		echo $msg;
    	}
    }
?>