<?php
    use PHPImageWorkshop\ImageWorkshop;
	use GifCreator\GifCreator;
	use GifFrameExtractor\GifFrameExtractor;
    class TextPlugin extends Plugin
    {
        public $type = 'html';
        public $name = 'Wpis tekstowy';

        private $allowedBBTags = 'b,i,s,ul,li,ol,br,center,right,left,img,url,size,color';

        // OG Tags
        public function ogTags($info)
        {
            return array(
                'title' => $info['title'],
                'image' => kernel::host().'/upload/'.$info['source']
            );
        }
        // User methods
        public function onDisplay($info)
        {
            return '<div class="posthtml"><a href="$1"><img src="'.kernel::host().'/upload/'.$info['source'].'" class="splash" title="'.$info['title'].'" alt="'.$info['title'].'" /></a><div class="short_content">'.BBCode::Parse($info['src'], $this->allowedBBTags, true).'</div></div>';
        }
        public function onSingleDisplay($info)
        {
            return '<div class="posthtml"><img src="'.kernel::host().'/upload/'.$info['source'].'" class="splash" title="'.$info['title'].'" alt="'.$info['title'].'" /><div class="full_content">'.BBCode::Parse($info['src'], $this->allowedBBTags).'</div></div>';
        }
        public function onProfileDisplay($info)
        {
            return kernel::host().'/upload/'.$info['source'];
        }
        public function onSave()
        {
            global $kernel, $page, $user;

    		if(isset($_POST['send_post'])) {
    		    if(!$this->verifyCaptcha(@$_POST['question']))
                {
                    $this->msg($kernel->lang['add']['captcha.error'],1);
                    return;
                }
                if(!empty($_POST['title']) && !empty($_POST['content']) && $_FILES['image']['name'])
                {
                    $is_waiting = 1;
                    $max_width = $this->maxObjectWidth;
                    $max_file_size = $page->load('max_file_size');
                    $owner = $user->userInfo('id');
                    $watermark = $page->load('watermark');
                    foreach($_POST as $key => $content)
                    {
                        $_POST[$key] = mysql_real_escape_string($content);
                    }

                    // Upload image
                    $overwrite = 0;
            		$dir = 'upload/';
            		$file_types = array(1=>'jpg','jpeg','gif','png','JPG','JPEG','GIF','PNG');
            		$file_mimes = array(1=>'image/jpg', 'image/jpeg', 'image/pjpeg', 'image/gif', 'image/png');
            		$file_name = md5(date('YmdHis').rand(1000,9999));
                    if(filesize($_FILES['image']['tmp_name']) <= $max_file_size*1024) {
						$file_ex = pathinfo($_FILES['image']['name']);
						$image_info = @getimagesize($_FILES['image']['tmp_name']);
            			if(array_search($file_ex['extension'],$file_types) && array_search($image_info['mime'],$file_mimes)) {
            				if($overwrite == 0 && file_exists($dir.$file_name.".".$file_ex['extension'])) $this->msg($kernel->lang['add']['fileExist'],1);
            				if(!move_uploaded_file($_FILES['image']['tmp_name'],$dir.$file_name.".".$file_ex['extension'])) $this->msg($kernel->lang['add']['upload.error'],1);
            				else {
            				    $upload_dir = $dir.$file_name.".".$file_ex['extension'];
					            $file_src = $file_name.".".$file_ex['extension'];
                                //Zmina rozmiaru obrazka
            					list($width, $height, $type, $attr) = getimagesize($upload_dir);
            					if($width > $max_width) {
            						require_once(ADMIN_DIRECTORY.'/lib/imageworkshop/ImageWorkshop.php');
            						$imageLayer = ImageWorkshop::initFromPath($upload_dir);
            						$imageLayer->resizeInPixel($max_width, null, true);
            						$createFolders = false;
            						$backgroundColor = null;
            						$imageQuality = 95;
            						$imageLayer->save($dir, $file_name.".".$file_ex['extension'], $createFolders, $backgroundColor, $imageQuality);
            					}

            					if($watermark) $this->watermark($upload_dir, $watermark, $dir);
            					$this->msg($kernel->lang['add']['upload.ok'],3);

                                // Add to DB
                                mysql_query("INSERT INTO `tentego_img` (`title`,`src`,`type`,`owner`,`cat`,`date`,`source`,`is_waiting`)
				                    VALUES ('{$_POST['title']}','{$_POST['content']}','{$this->type}','{$owner}','{$_POST['cat']}','".date('Y-m-d H:i:s')."','{$file_src}','{$is_waiting}')");

                            }
                        }
                    }
                }
                else
                {
                    $this->msg($kernel->lang['add']['fillrequired'],1);
                }
    		}
        }
        public function form()
        {
            global $kernel, $rewrite, $page, $user;

    		$text = NULL;
    		foreach(self::$categories as $cat) {
    			$text .= '<option value="'.$cat['id'].'">'.$cat['name'].'</option>'."\n";
    		}

            $bbcodes = explode(',', $this->allowedBBTags);
            $allowed = array();
            foreach($bbcodes as $bbcode)
            {
                $allowed[] = '['.$bbcode.']';
            }

            echo '<form action="'.$rewrite->add.'" method="post" enctype="multipart/form-data">
        		<label>'.$kernel->lang['add']['form.title'].'*</label>
        		<input type="text" name="title" maxlength="64" value="'.(isset($_POST['title'])?htmlspecialchars($_POST['title']):'').'" />
        		<label>'.$kernel->lang['add']['form.post.image'].'*</label>
        		<input type="file" accept="image/*" name="image" />
        		<label>'.$kernel->lang['add']['form.cat'].'*</label>
        		<select name="cat">
        			'.$text.'
        		</select>
                <label>'.$kernel->lang['add']['form.content'].'*</label>
                <span style="text-align:left; padding:5px 0; font-size:10px;">'.$kernel->lang['add']['form.allowed.bbcode'].': <b>'.implode(', ', $allowed).'</b></span>
                <textarea name="content">'.(isset($_POST['content'])?htmlspecialchars($_POST['content']):'').'</textarea>
        		<label><img src="'.kernel::host().'/_themes/_captcha/image.php" alt="Captcha"></label>
        		<input type="text" name="question" '.(($page->load("admin_captcha") && $user->verifyLogin() && $user->userInfo('rank') == 0)?'disabled':'').'/>
        		<br/>
        		<input type="submit" name="send_post" value="'.$kernel->lang['add']['form.submit'].'" />
        	</form>';
        }

        // Admin methods
        public function onAdminPreview($info)
        {
            parse_str(parse_url(htmlspecialchars_decode($info['src']), PHP_URL_QUERY), $src);
            return array(
                'url'       => '../upload/'.$info['source'],
                'img'       => '?go=manager&feature=thumb&img=../upload/'.$info['source'].'&token='.$_SESSION[kernel::host().'-us_token'],
            );
        }
        public function onAdminEdit($info)
        {
            $query['categories'] = mysql_query("SELECT * FROM tentego_img_cat");
            while($fetch = mysql_fetch_array(($query['categories'])))
            {
                $categories[] = '<option value="'.$fetch['id'].'"'.( ($fetch['id']==$info['cat'])?' selected':'' ).'>'.$fetch['name'].'</option>';
            }
            $categories = implode("\n", $categories);

            $info['src'] = str_replace(array('\\r\\n','\r\\n','r\\n','\r\n', '\n', '\r'), "\n", $info['src']);
            $return = array(
                'Tytuł'    				=> '<input type="text" name="img[title]" value="'.($info['title']).'" />',
				'Cover'     			=> '<input type="text" name="img[source]" value="'.$info['source'].'" />',
                'Data dodania'      			=> '<input type="text" name="img[date]" value="'.date('Y-m-d H:i:s', strtotime($info['date'])).'" />',
				'Data opublikowania'	=> '<input type="text" name="img[rel_date]" value="'.date('Y-m-d H:i:s', strtotime($info['rel_date'])).'" />',
				'Kategoria' 			=> '<select name="img[cat]">'.$categories.'</select>',
                'Treść'     			=> '<textarea name="img[src]">'.$info['src'].'</textarea>',
            );

            return $return;
        }
        public function onAdminSave()
        {
            $data = array();
            foreach($_POST['img'] as $key => $content)
            {
                if($key == 'src')
                    $data[$key] = $content;
                else
                    $data[$key] = mysql_real_escape_string(htmlspecialchars($content, ENT_QUOTES));
            }
            $query = sprintf("UPDATE tentego_img SET title = '%s', date = '%s', rel_date = '%s', src = '%s', cat = '%s', source = '%s' WHERE id = %d",
                                $data['title'], $data['date'], $data['rel_date'], $data['src'], $data['cat'], $data['source'], intval($_GET['id']));

            return mysql_query($query);
        }
        public function onAdminDelete($info)
        {
            if(mysql_query("DELETE FROM `tentego_img` WHERE `id`=".$info['id']))
            {
	            if(unlink('../upload/'.$info['source'])) kernel::make_notify("Usunięto obrazek z serwera.");
            	else kernel::make_notify("Wystąpił błąd podczas usuwania obrazka.");
            	kernel::make_notify("Pomyślnie usunięto wpis.");
			}
			else kernel::make_notify("Wystąpił błąd podczas usuwania wpisu.");
        }
    }

    class BBCode
    {
        public static function Parse($text, $allowed = 'b,i,s,ul,li,ol,br,center,right,left,img,url,size,color', $remove = false, $substr = 255)
        {
            // Remove html tags
            $text = htmlspecialchars(strip_tags($text), ENT_QUOTES);
            // Basic BBCode
            $allowed = explode(',', $allowed);
            $bbcode = array();
            $replace = array();
            if(in_array('b', $allowed))
            {
                array_push($bbcode, '#\[b](.+)\[/b\]#Usi');
                array_push($replace, '<b>$1</b>');
            }
            if(in_array('i', $allowed))
            {
                array_push($bbcode, '#\[i](.+)\[/i\]#Usi');
                array_push($replace, '<i>$1</i>');
            }
            if(in_array('s', $allowed))
            {
                array_push($bbcode, '#\[s](.+)\[/s\]#Usi');
                array_push($replace, '<s>$1</s>');
            }
            if(in_array('ul', $allowed))
            {
                array_push($bbcode, '#\[ul](.+)\[/ul\]#Usi');
                array_push($replace, '<ul>$1</ul>');
            }
            if(in_array('li', $allowed))
            {
                array_push($bbcode, '#\[li](.+)\[/li\]#Usi');
                array_push($replace, '<li>$1</li>');
            }
            if(in_array('ol', $allowed))
            {
                array_push($bbcode, '#\[ol](.+)\[/ol\]#Usi');
                array_push($replace, '<ol>$1</ol>');
            }
            if(in_array('br', $allowed))
            {
                array_push($bbcode, '#\[br\]#si');
                array_push($replace, '<br/>');
            }
            // Replace basic BBCode
            if($remove) $replace = '$1';
            $text = preg_replace($bbcode, $replace, $text);

            //Advanced BBCode
            $bbcode = array();
            $replace = array();
            if(in_array('center', $allowed))
            {
                array_push($bbcode, '#\[center](.+)\[/center\]#Usi');
                if($remove)
                    array_push($replace, '$1');
                else
                    array_push($replace, '<div style="text-align:center;" class="bbcode_center">$1</div>');
            }
            if(in_array('left', $allowed))
            {
                array_push($bbcode, '#\[left](.+)\[/left\]#Usi');
                if($remove)
                    array_push($replace, '$1');
                else
                    array_push($replace, '<div style="text-align:left;" class="bbcode_center">$1</div>');
            }
            if(in_array('right', $allowed))
            {
                array_push($bbcode, '#\[right](.+)\[/right\]#Usi');
                if($remove)
                    array_push($replace, '$1');
                else
                    array_push($replace, '<div style="text-align:right;" class="bbcode_center">$1</div>');
            }
            if(in_array('size', $allowed))
            {
                array_push($bbcode, '#\[size\=(.+)](.+)\[/size\]#Usi');
                if($remove)
                    array_push($replace, '$2');
                else
                    array_push($replace, '<span style="font-size:$1px">$2</span>');
            }
            if(in_array('color', $allowed))
            {
                array_push($bbcode, '#\[color\=(.+)](.+)\[/color\]#Usi');
                if($remove)
                    array_push($replace, '$2');
                else
                    array_push($replace, '<span style="color:$1">$2</span>');
            }
            if(in_array('url', $allowed))
            {
                array_push($bbcode, '#\[url]((?:ftp|https?)://.*?)\[/url]#Usi', '#\[url=((?:ftp|https?)://.*?)](.+)\[/url\]#Usi');
                if($remove)
                    array_push($replace, '$1', '$2');
                else
                    array_push($replace, '<a rel="nofollow" target="_blank" class="bbcode_url" href="$1">$1</a>', '<a rel="nofollow" target="_blank" class="bbcode_url" href="$1">$2</a>');
            }
            if(in_array('img', $allowed) && !$remove)
            {
                array_push($bbcode, '#\[img](.+)\[/img]#Usi', '#\[img=(.+)](.+)\[/img]#Usi');
                array_push($replace, '<img src="$1" alt="$1" />', '<img src="$1" alt="$2" />');
            }

            // Add formating
            $text = str_replace(array('\\r\\n','\r\\n','r\\n','\r\n', '\n', '\r'), '<br/>', nl2br($text));
            $text = str_replace('<br/>', '[br]', $text);

            // Replace advanced BBCode
            $text = preg_replace($bbcode, $replace, $text);

            // Replace advanced BBCode
            $text = preg_replace($bbcode, $replace, $text);

            if($remove)
                return (substr(strip_tags($text), 0, $substr).((strlen(strip_tags($text)) > $substr)?'...':''));


            return $text;
        }
    }

?>