<?php
    class YoutubePlugin extends Plugin
    {
        public $type = 'youtube';
        public $name = 'YouTube';

        public function ogTags($info)
        {
            parse_str(parse_url($info['src'], PHP_URL_QUERY), $src);

            return array(
                'title' => $info['title'],
                'image' => $this->YouTubeExists($src['v'], false)[0] ? 'http://i1.ytimg.com/vi_webp/'.$src['v'].'/hqdefault.webp' : 'http://i1.ytimg.com/vi/'.$src['v'].'/hqdefault.jpg'
            );
        }
        // User methods
        public function onDisplay($info)
        {
            //parse_str(parse_url(htmlspecialchars_decode($info['src']), PHP_URL_QUERY), $src);
            preg_match("/^(http|https):\/\/(?:www\.)?(?:youtube.com|youtu.be)\/(?:watch\?(?=.*v=([\w\-]+))(?:\S+)?|([\w\-]+))$/", $info['src'], $matches);

            return '<iframe src="http://www.youtube.com/embed/'.$matches[2].'?wmode=transparent" frameborder="0" allowfullscreen></iframe>';
        }
        public function onSingleDisplay($info)
        {
            return $this->onDisplay($info);
        }
        public function onProfileDisplay($info)
        {
            parse_str(parse_url(htmlspecialchars_decode($info['src']), PHP_URL_QUERY), $src);
            return $this->YouTubeExists($src['v'], false)[0] ? 'http://i1.ytimg.com/vi_webp/'.$src['v'].'/hqdefault.webp' : 'http://i1.ytimg.com/vi/'.$src['v'].'/hqdefault.jpg';
        }
        public function onSave()
        {
            global $kernel, $user, $page;
            if(isset($_POST['send_youtube'])) {

                $max_width = $this->maxObjectWidth;
                $max_file_size = $page->load('max_file_size');
                $owner = $user->userInfo('id');
                $watermark = $page->load('watermark');

    			if(empty($_POST['title']) || empty($_POST['video_url'])) { $this->msg($kernel->lang['add']['fillrequired'],1); }
    			else {
    				if(!$this->verifyCaptcha(@$_POST['question'])) $this->msg($kernel->lang['add']['captcha.error'],1);
    				else {
    					$title = mysql_real_escape_string(htmlspecialchars($_POST['title'],ENT_QUOTES));
    					$src = mysql_real_escape_string(htmlspecialchars($_POST['video_url']));
    					$cat = mysql_real_escape_string(htmlspecialchars($_POST['cat']));
    					$date = date('Y-m-d H:i:s');

            			$source = 'YouTube.com';
            			$type = 'youtube';
            			if(!preg_match("/^(http|https):\/\/(?:www\.)?(?:youtube.com|youtu.be)\/(?:watch\?(?=.*v=([\w\-]+))(?:\S+)?|([\w\-]+))$/", $src, $matches)) { $this->msg($kernel->lang['add']['video.address.error'],1); return false; }

                        $matches = array_values(array_filter($matches));
            			// Sprawdzanie czy video istnieje - YouTube
            			//parse_str(parse_url($_POST['video_url'], PHP_URL_QUERY), $parsedLink);
                        if(!isset($matches[2])) { $this->msg($kernel->lang['add']['video.address.error'],1); return false; }

                        if(!$this->YouTubeExists($matches[2])) { $this->msg($kernel->lang['add']['video.doesNotExist'],1); return false; }

                        $src = 'http://www.youtube.com/watch?v='.$matches[2];

    					$is_waiting = 1;
    					if(empty($_SESSION['login'])) $owner = 0;

    					$query = mysql_query("INSERT INTO `tentego_img` (`title`,`src`,`type`,`owner`,`cat`,`date`,`source`,`is_waiting`)
    										VALUES ('$title','$src','$type','$owner','$cat','$date','$source','$is_waiting')");

    					if($query) $this->msg($kernel->lang['add']['notify.ok'],3);
    					else $this->msg($kernel->lang['add']['notify.error'],1);
    				}
    			}
    		}
        }
        public function form()
        {
            global $kernel, $rewrite, $page, $user;

            $text = NULL;
    		foreach(self::$categories as $cat) {
    			$text .= '<option value="'.$cat['id'].'">'.$cat['name'].'</option>'."\n";
    		}

            echo '<form action="'.$rewrite->add.'" method="post" enctype="multipart/form-data">
            		<input type="hidden" name="type" value="youtube" />
            		<label>'.$kernel->lang['add']['form.name'].'</label>
            		<input type="text" name="title" maxlength="64" value="'.(isset($_POST['title'])?htmlspecialchars($_POST['title']):'').'" />
            		<label>'.$kernel->lang['add']['form.youtube'].'</label>
            		<input type="text" name="video_url" value="'.(isset($_POST['video_url'])?htmlspecialchars($_POST['video_url']):'').'" />
            		<label>'.$kernel->lang['add']['form.cat'].'</label>
            		<select name="cat">
            			'.$text.'
            		</select>
            		<label><img src="'.kernel::host().'/_themes/_captcha/image.php" alt="Captcha"></label>
            		<input type="text" name="question" '.(($page->load("admin_captcha") && $user->verifyLogin() && $user->userInfo('rank') == 0)?'disabled':'').'/>
            		<br/>
            		<input type="submit" name="send_youtube" value="'.$kernel->lang['add']['form.submit'].'" />
            	</form>';
        }

        // Admin methods
        public function onAdminPreview($info)
        {
            parse_str(parse_url(htmlspecialchars_decode($info['src']), PHP_URL_QUERY), $src);
            return array(
                'shadowbox' => 'width=720;height=405',
                'url'       => 'http://www.youtube.com/embed/'.$src['v'].'?wmode=transparent',
                'img'       => $this->YouTubeExists($src['v'], false)[0] ? 'http://i1.ytimg.com/vi_webp/'.$src['v'].'/hqdefault.webp' : 'http://i1.ytimg.com/vi/'.$src['v'].'/hqdefault.jpg'
            );
        }
        public function onAdminEdit($info)
        {
            $query['categories'] = mysql_query("SELECT * FROM tentego_img_cat");
            while($fetch = mysql_fetch_array(($query['categories'])))
            {
                $categories[] = '<option value="'.$fetch['id'].'"'.( ($fetch['id']==$info['cat'])?' selected':'' ).'>'.$fetch['name'].'</option>';
            }
            $categories = implode("\n", $categories);

            $return = array(
                'Tytuł'         		=> '<input type="text" name="img[title]" value="'.($info['title']).'" />',
				'Adres YouTube'   		=> '<input type="text" name="img[src]" value="'.$info['src'].'" />',
                'Data'          		=> '<input type="text" name="img[date]" value="'.date('Y-m-d H:i:s', strtotime($info['date'])).'" />',
				'Data opublikowania'	=> '<input type="text" name="img[rel_date]" value="'.date('Y-m-d H:i:s', strtotime($info['rel_date'])).'" />',
                'Kategoria'     		=> '<select name="img[cat]">'.$categories.'</select>',
                'Źródło'        		=> '<input type="text" name="img[source]" value="'.$info['source'].'" />',
            );

            return $return;
        }
        public function onAdminSave()
        {
            $data = array();
            foreach($_POST['img'] as $key => $content)
            {
                $data[$key] = mysql_real_escape_string(htmlspecialchars($content, ENT_QUOTES));
            }
            $query = sprintf("UPDATE tentego_img SET title = '%s', date = '%s', rel_date = '%s', src = '%s', cat = '%s', source = '%s' WHERE id = %d",
                                $data['title'], $data['date'], $data['rel_date'], $data['src'], $data['cat'], $data['source'], intval($_GET['id']));

            return mysql_query($query);
        }
        public function onAdminDelete($info)
        {
            if(mysql_query("DELETE FROM `tentego_img` WHERE `id`=".$info['id']))
            {
            	kernel::make_notify("Pomyślnie usunięto wpis.");
			}
			else kernel::make_notify("Wystąpił błąd podczas usuwania wpisu.");
        }

        private function YouTubeExists($id, $bool = true)
        {
            if(isset($this->yt_cache[$id]))
            {
                if($bool)
                    return array_sum($this->yt_cache[$id]) ? true : false;
                else
                    return $this->yt_cache[$id];
            }

            $getHeadersToVerify[0] = get_headers("https://i.ytimg.com/vi_webp/".$id."/mqdefault.webp");
            $getHeadersToVerify[1] = get_headers("https://i.ytimg.com/vi/".$id."/mqdefault.jpg");

            $return = array();
            $return[0] = strpos($getHeadersToVerify[0][0],'200') ? 1 : 0;
            $return[1] = strpos($getHeadersToVerify[1][0],'200') ? 1 : 0;

            $this->yt_cache[$id] = $return;

            if($bool)
                return array_sum($return) ? true : false;
            else
                return $return;
        }
    }

?>